import { PropsWithChildren } from 'react';
import { VtkConstructor } from '../types';
interface Props extends PropsWithChildren {
    /**
     * Can either be a string containing the name of the vtkClass or a vtk object constructor.
     *
     * If a string, then that vtk class must be registered (i.e. by import).
     */
    vtkClass: string | VtkConstructor;
    /**
     * The properties and state object to pass to the algorithm.
     */
    state?: Record<string, unknown>;
    /**
     * An optional port number for connections.
     */
    port?: number;
}
export default function Algorithm(props: Props): JSX.Element;
export {};
