import { Matrix3x3, Vector3 } from '@kitware/vtk.js/types';
import { PropsWithChildren } from 'react';
interface Props extends PropsWithChildren {
    /**
     * downstream connection port
     */
    port?: number;
    /**
     * Image dimensions along x, y, z
     */
    dimensions?: Vector3;
    /**
     * Image spacing
     */
    spacing?: Vector3;
    /**
     * Image origin
     */
    origin?: Vector3;
    /**
     * Image orientation. Matrix is a 6-tuple, column-major ordering.
     */
    direction?: Matrix3x3;
}
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
