import { PropsWithChildren } from 'react';
import { ManipulatorSettings } from '../modules/useInteractorStyle';
import { Props as OpenGLRenderWindowProps } from '../OpenGLRenderWindow';
import { Props as RendererProps } from '../Renderer';
import { Props as RenderWindowProps } from '../RenderWindow';
export interface Props extends PropsWithChildren, OpenGLRenderWindowProps, RenderWindowProps, RendererProps {
    /**
     * Show/Hide orientation axes.
     */
    /**
     * Configure the interactions
     */
    interactorSettings?: ManipulatorSettings[];
    /**
     * Whether to automatically re-set the interactor style's center of rotation. (default: true)
     *
     * This is a convenience property for interactor styles that support setCenterOfRotation().
     */
    autoCenterOfRotation?: boolean;
}
export declare const DefaultProps: {
    interactorSettings: ManipulatorSettings[];
    autoCenterOfRotation: boolean;
};
