import vtkProp, { IPropInitialValues } from '@kitware/vtk.js/Rendering/Core/Prop';
import { BooleanAccumulator } from '../../utils/useBooleanAccumulator';
/**
 * Params to useProp.
 */
type Params<T, A> = {
    constructor: () => T;
    id: string | undefined;
    props: A | undefined;
    trackModified: BooleanAccumulator;
};
/**
 * Returns a vtkProp getter.
 *
 * Must be used in an ordered unmount context for
 * proper unmount order.
 */
export default function useProp<T extends vtkProp, A extends IPropInitialValues>({ constructor, id, props, trackModified }: Params<T, A>): () => T;
export {};
