'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('@kitware/vtk.js/Rendering/Misc/RenderingAPIs');
require('@kitware/vtk.js/Rendering/OpenGL/Profiles/Geometry');
require('@kitware/vtk.js/Rendering/OpenGL/Profiles/Glyph');
require('@kitware/vtk.js/Rendering/OpenGL/Profiles/Volume');
var jsxRuntime = require('react/jsx-runtime');
var vtk = require('@kitware/vtk.js/vtk');
var react = require('react');
var vtkDataArray = require('@kitware/vtk.js/Common/Core/DataArray');
var macros = require('@kitware/vtk.js/macros');
var Base64 = require('@kitware/vtk.js/Common/Core/Base64');
var vtkActor2D = require('@kitware/vtk.js/Rendering/Core/Actor2D');
var Constants = require('@kitware/vtk.js/Rendering/Core/Coordinate/Constants');
var vtkMapper2D = require('@kitware/vtk.js/Rendering/Core/Mapper2D');
var vtkColorTransferFunction = require('@kitware/vtk.js/Rendering/Core/ColorTransferFunction');
var vtkColorMaps = require('@kitware/vtk.js/Rendering/Core/ColorTransferFunction/ColorMaps');
var vtkCoordinate = require('@kitware/vtk.js/Rendering/Core/Coordinate');
var vtkActor = require('@kitware/vtk.js/Rendering/Core/Actor');
var vtkMapper = require('@kitware/vtk.js/Rendering/Core/Mapper');
var vtkImageData = require('@kitware/vtk.js/Common/DataModel/ImageData');
var vtkOpenGLRenderWindow = require('@kitware/vtk.js/Rendering/OpenGL/RenderWindow');
var vtkRenderWindow = require('@kitware/vtk.js/Rendering/Core/RenderWindow');
var vtkRenderWindowInteractor = require('@kitware/vtk.js/Rendering/Core/RenderWindowInteractor');
var Constants_js = require('@kitware/vtk.js/Common/DataModel/DataSet/Constants.js');
var vtkOpenGLHardwareSelector = require('@kitware/vtk.js/Rendering/OpenGL/HardwareSelector');
var vtkPolyData = require('@kitware/vtk.js/Common/DataModel/PolyData');
var Base64_js = require('@kitware/vtk.js/Common/Core/Base64.js');
var vtkImageMapper = require('@kitware/vtk.js/Rendering/Core/ImageMapper');
var vtkImageSlice = require('@kitware/vtk.js/Rendering/Core/ImageSlice');
var vtkGestureCameraManipulator = require('@kitware/vtk.js/Interaction/Manipulators/GestureCameraManipulator');
var vtkMouseBoxSelectorManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseBoxSelectorManipulator');
var vtkMouseCameraTrackballMultiRotateManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballMultiRotateManipulator');
var vtkMouseCameraTrackballPanManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballPanManipulator');
var vtkMouseCameraTrackballRollManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballRollManipulator');
var vtkMouseCameraTrackballRotateManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballRotateManipulator');
var vtkMouseCameraTrackballZoomManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballZoomManipulator');
var vtkMouseCameraTrackballZoomToMouseManipulator = require('@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballZoomToMouseManipulator');
var vtkInteractorStyleManipulator = require('@kitware/vtk.js/Interaction/Style/InteractorStyleManipulator');
var deepEqual = require('deep-equal');
var vtkRenderer = require('@kitware/vtk.js/Rendering/Core/Renderer');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var vtk__default = /*#__PURE__*/_interopDefaultLegacy(vtk);
var vtkDataArray__default = /*#__PURE__*/_interopDefaultLegacy(vtkDataArray);
var vtkActor2D__default = /*#__PURE__*/_interopDefaultLegacy(vtkActor2D);
var vtkMapper2D__default = /*#__PURE__*/_interopDefaultLegacy(vtkMapper2D);
var vtkColorTransferFunction__default = /*#__PURE__*/_interopDefaultLegacy(vtkColorTransferFunction);
var vtkColorMaps__default = /*#__PURE__*/_interopDefaultLegacy(vtkColorMaps);
var vtkCoordinate__default = /*#__PURE__*/_interopDefaultLegacy(vtkCoordinate);
var vtkActor__default = /*#__PURE__*/_interopDefaultLegacy(vtkActor);
var vtkMapper__default = /*#__PURE__*/_interopDefaultLegacy(vtkMapper);
var vtkImageData__default = /*#__PURE__*/_interopDefaultLegacy(vtkImageData);
var vtkOpenGLRenderWindow__default = /*#__PURE__*/_interopDefaultLegacy(vtkOpenGLRenderWindow);
var vtkRenderWindow__default = /*#__PURE__*/_interopDefaultLegacy(vtkRenderWindow);
var vtkRenderWindowInteractor__default = /*#__PURE__*/_interopDefaultLegacy(vtkRenderWindowInteractor);
var vtkOpenGLHardwareSelector__default = /*#__PURE__*/_interopDefaultLegacy(vtkOpenGLHardwareSelector);
var vtkPolyData__default = /*#__PURE__*/_interopDefaultLegacy(vtkPolyData);
var vtkImageMapper__default = /*#__PURE__*/_interopDefaultLegacy(vtkImageMapper);
var vtkImageSlice__default = /*#__PURE__*/_interopDefaultLegacy(vtkImageSlice);
var vtkGestureCameraManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkGestureCameraManipulator);
var vtkMouseBoxSelectorManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseBoxSelectorManipulator);
var vtkMouseCameraTrackballMultiRotateManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballMultiRotateManipulator);
var vtkMouseCameraTrackballPanManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballPanManipulator);
var vtkMouseCameraTrackballRollManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballRollManipulator);
var vtkMouseCameraTrackballRotateManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballRotateManipulator);
var vtkMouseCameraTrackballZoomManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballZoomManipulator);
var vtkMouseCameraTrackballZoomToMouseManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkMouseCameraTrackballZoomToMouseManipulator);
var vtkInteractorStyleManipulator__default = /*#__PURE__*/_interopDefaultLegacy(vtkInteractorStyleManipulator);
var deepEqual__default = /*#__PURE__*/_interopDefaultLegacy(deepEqual);
var vtkRenderer__default = /*#__PURE__*/_interopDefaultLegacy(vtkRenderer);

/**
 * Tracks the usage of a particular object, triggering a deletion callback when refs hit zero and the object is marked for deletion.
 *
 * register() is the entrypoint for tracking an object.
 * markForDeletion() is the counterpart to register(), indicating that the object should be deleted in the future.
 * incRefCount() and decRefCount() should be used to track when code uses/stops using the object.
 * unregister() is used only if there's not reason to continue tracking the object.
 */
class DeletionRegistry {
    constructor() {
        this.refCount = new Map();
        this.callbacks = new Map();
        this.toDelete = new Set();
    }
    get liveCount() {
        return this.refCount.size;
    }
    register(obj, deleteCallback) {
        this.refCount.set(obj, 0);
        this.callbacks.set(obj, deleteCallback);
    }
    unregister(obj) {
        this.refCount.delete(obj);
        this.callbacks.delete(obj);
        this.toDelete.delete(obj);
    }
    markForDeletion(obj) {
        if (this.refCount.has(obj) && this.callbacks.has(obj)) {
            this.toDelete.add(obj);
            this.tryToDispose(obj);
        }
    }
    incRefCount(obj) {
        var _a;
        const count = (_a = this.refCount.get(obj)) !== null && _a !== void 0 ? _a : 0;
        this.refCount.set(obj, count + 1);
    }
    decRefCount(obj) {
        let count = this.refCount.get(obj);
        if (count != null) {
            if (count === 0)
                throw new Error('Cannot decrease ref count below 0');
            count -= 1;
            this.refCount.set(obj, count);
            if (count === 0) {
                this.tryToDispose(obj);
            }
        }
    }
    tryToDispose(obj) {
        var _a;
        if (!this.toDelete.has(obj))
            return;
        const count = (_a = this.refCount.get(obj)) !== null && _a !== void 0 ? _a : Infinity;
        const callback = this.callbacks.get(obj);
        if (count === 0 && callback) {
            callback(obj);
            this.refCount.delete(obj);
            this.callbacks.delete(obj);
            this.toDelete.delete(obj);
        }
    }
}
const deletionRegistry = new DeletionRegistry();

function useGetterRef(initFunc) {
    const ref = react.useRef(null);
    const getterRef = react.useRef(() => {
        if (ref.current === null) {
            ref.current = initFunc();
        }
        return ref.current;
    });
    // these values are referentially stable
    return [ref, getterRef.current];
}

function usePrevious(val) {
    const ref = react.useRef(undefined);
    react.useEffect(() => {
        ref.current = val;
    });
    return ref.current;
}

function useUnmount(func) {
    const funcRef = react.useRef(func);
    funcRef.current = func;
    react.useEffect(() => {
        return () => {
            funcRef.current();
        };
    }, []);
}

const OpenGLRenderWindowContext = react.createContext(null);
const RenderWindowContext = react.createContext(null);
const RendererContext = react.createContext(null);
const FieldDataContext = react.createContext(null);
const DatasetContext = react.createContext(null);
const RepresentationContext = react.createContext(null);
const DownstreamContext = react.createContext(null);
const ShareDataSetContext = react.createContext(null);
const MultiViewRootContext = react.createContext(false);
const ViewContext = react.createContext(null);
function useRenderWindowContext() {
    const rw = react.useContext(RenderWindowContext);
    if (!rw)
        throw new Error('No RenderWindow context!');
    return rw;
}
function useRendererContext() {
    const r = react.useContext(RendererContext);
    if (!r)
        throw new Error('No Renderer context!');
    return r;
}
function useFieldData() {
    const fd = react.useContext(FieldDataContext);
    if (!fd)
        throw new Error('No FieldData context!');
    return fd;
}
function useDataset() {
    const ds = react.useContext(DatasetContext);
    if (!ds)
        throw new Error('No Dataset context!');
    return ds;
}
function useRepresentation() {
    const rep = react.useContext(RepresentationContext);
    if (!rep)
        throw new Error('No Representation context!');
    return rep;
}
function useDownstream() {
    const ds = react.useContext(DownstreamContext);
    if (!ds)
        throw new Error('No Downstream context!');
    return ds;
}
function useShareDataSet() {
    const share = react.useContext(ShareDataSetContext);
    if (!share)
        throw new Error('No ShareDataSet context!');
    return share;
}

var contexts = /*#__PURE__*/Object.freeze({
    __proto__: null,
    OpenGLRenderWindowContext: OpenGLRenderWindowContext,
    RenderWindowContext: RenderWindowContext,
    RendererContext: RendererContext,
    FieldDataContext: FieldDataContext,
    DatasetContext: DatasetContext,
    RepresentationContext: RepresentationContext,
    DownstreamContext: DownstreamContext,
    ShareDataSetContext: ShareDataSetContext,
    MultiViewRootContext: MultiViewRootContext,
    ViewContext: ViewContext,
    useRenderWindowContext: useRenderWindowContext,
    useRendererContext: useRendererContext,
    useFieldData: useFieldData,
    useDataset: useDataset,
    useRepresentation: useRepresentation,
    useDownstream: useDownstream,
    useShareDataSet: useShareDataSet
});

function Algorithm(props) {
    const prev = usePrevious(props);
    const { vtkClass, state, port = 0 } = props;
    const createAlgo = react.useCallback(() => {
        if (typeof vtkClass === 'string') {
            return vtk__default["default"](Object.assign({ vtkClass }, state));
        }
        return vtkClass.newInstance(state);
    }, [vtkClass, state]);
    const [algoRef, getAlgorithm] = useGetterRef(() => {
        const algo = createAlgo();
        deletionRegistry.register(algo, () => algo.delete());
        return algo;
    });
    const representation = useRepresentation();
    const downstream = useDownstream();
    react.useEffect(() => {
        let algoChanged = false;
        if (!algoRef.current) {
            algoRef.current = createAlgo();
            algoChanged = true;
        }
        else if (vtkClass !== (prev === null || prev === void 0 ? void 0 : prev.vtkClass)) {
            const curAlgo = algoRef.current;
            const newAlgo = createAlgo();
            // copy connections over from current algorithm
            const nbInputs = curAlgo.getNumberOfInputPorts();
            for (let i = 0; i < nbInputs; i++) {
                const connection = curAlgo.getInputConnection(i);
                if (connection) {
                    newAlgo.setInputConnection(connection, i);
                }
                else {
                    newAlgo.setInputData(curAlgo.getInputData(i), i);
                }
            }
            algoRef.current = newAlgo;
            deletionRegistry.markForDeletion(curAlgo);
            algoChanged = true;
        }
        else if (state) {
            const modified = algoRef.current.set(state);
            if (modified) {
                representation.dataChanged();
            }
        }
        if (algoChanged) {
            downstream.setInputConnection(algoRef.current.getOutputPort(), port);
            // if a source algo, then it already produces data
            if (algoRef.current.getNumberOfInputPorts() === 0) {
                representation.dataAvailable();
            }
        }
    }, [
        prev,
        vtkClass,
        state,
        port,
        createAlgo,
        algoRef,
        representation,
        downstream,
    ]);
    useUnmount(() => {
        if (algoRef.current) {
            deletionRegistry.markForDeletion(algoRef.current);
            algoRef.current = null;
        }
    });
    const fwdDownstream = react.useMemo(() => ({
        setInputData: (...args) => getAlgorithm().setInputData(...args),
        setInputConnection: (...args) => getAlgorithm().setInputConnection(...args),
    }), [getAlgorithm]);
    return (jsxRuntime.jsx(DownstreamContext.Provider, Object.assign({ value: fwdDownstream }, { children: props.children })));
}

const NUMPY_DTYPES = {
    int32: Int32Array,
    int16: Int16Array,
    int8: Int8Array,
    uint32: Uint32Array,
    uint16: Uint16Array,
    uint8: Uint8Array,
    float32: Float32Array,
    float64: Float64Array,
};

Object.freeze(() => {
    /* noop */
});
const TypedArrayLookup = {
    [macros.TYPED_ARRAYS.Uint8Array]: Uint8Array,
    [macros.TYPED_ARRAYS.Uint16Array]: Uint16Array,
    [macros.TYPED_ARRAYS.Uint32Array]: Uint32Array,
    [macros.TYPED_ARRAYS.Int8Array]: Int8Array,
    [macros.TYPED_ARRAYS.Int16Array]: Int16Array,
    [macros.TYPED_ARRAYS.Int32Array]: Int32Array,
    [macros.TYPED_ARRAYS.Float32Array]: Float32Array,
    [macros.TYPED_ARRAYS.Float64Array]: Float64Array,
};
function dataArraySize(v) {
    if ('length' in v)
        return v.length;
    return v.shape.reduce((size, dim) => size * dim, 1);
}
function toTypedArray(values, constructor) {
    if (Array.isArray(values)) {
        return constructor.from(values);
    }
    if ('dtype' in values) {
        const { bvals, dtype } = values;
        const arrayBuffer = Base64.toArrayBuffer(bvals);
        return new NUMPY_DTYPES[dtype](arrayBuffer);
    }
    return values;
}
function pick(source, ...keys) {
    const lookup = new Set(keys);
    return Object.entries(source)
        .filter(([key]) => lookup.has(key))
        .reduce((out, [key, value]) => (Object.assign(Object.assign({}, out), { [key]: value })), {});
}
function omit(source, ...keys) {
    const lookup = new Set(keys);
    return Object.entries(source)
        .filter(([key]) => !lookup.has(key))
        .reduce((out, [key, value]) => (Object.assign(Object.assign({}, out), { [key]: value })), {});
}

const DefaultProps$8 = {
    registration: 'addArray',
    name: 'scalars',
    type: 'Float32Array',
    numberOfComponents: 1,
};
function DataArray(props) {
    const prev = usePrevious(Object.assign(Object.assign({}, DefaultProps$8), props));
    const [daRef, getDataArray] = useGetterRef(() => {
        const da = vtkDataArray__default["default"].newInstance({
            name: 'scalars',
            empty: true,
        });
        deletionRegistry.register(da, () => da.delete());
        return da;
    });
    const getFieldData = useFieldData();
    const dataset = useDataset();
    const { registration = DefaultProps$8.registration } = props;
    const { name = DefaultProps$8.name, type = DefaultProps$8.type, values = [], numberOfComponents = DefaultProps$8.numberOfComponents, range, } = props;
    // register array with the dataset must happen before dataset.modified()
    // cleanup should happend before the polydata is deleted
    react.useEffect(() => {
        const array = getDataArray();
        const ds = dataset.getDataSet();
        deletionRegistry.incRefCount(ds);
        const fieldData = getFieldData();
        const register = fieldData[registration];
        register(array);
        ds.modified();
        return () => {
            fieldData.removeArray(array.getName());
            deletionRegistry.decRefCount(ds);
        };
    }, [registration, dataset, getDataArray, getFieldData]);
    react.useEffect(() => {
        const array = getDataArray();
        let modified = !prev;
        modified = array.setName(name) || modified;
        modified = type !== (prev === null || prev === void 0 ? void 0 : prev.type) || modified;
        modified = numberOfComponents !== (prev === null || prev === void 0 ? void 0 : prev.numberOfComponents) || modified;
        modified = values !== (prev === null || prev === void 0 ? void 0 : prev.values) || modified;
        if (modified) {
            const typedArrayClass = TypedArrayLookup[macros.TYPED_ARRAYS[type]];
            array.setData(toTypedArray(values, typedArrayClass), numberOfComponents);
            if (range) {
                array.setRange(range, numberOfComponents);
            }
        }
        if (modified)
            dataset.modified();
    });
    useUnmount(() => {
        if (daRef.current) {
            deletionRegistry.markForDeletion(daRef.current);
            daRef.current = null;
        }
    });
    return null;
}

/**
 * Compares two objects.
 *
 * If any object is undefined, then the comparison fails.
 */
function compareShallowObject(cur, prev) {
    if (!cur || typeof cur !== 'object')
        return false;
    if (!prev || typeof prev !== 'object')
        return false;
    if (cur === prev)
        return true;
    const keys1 = Object.keys(cur);
    const keys2 = Object.keys(prev);
    const keyset2 = new Set(keys2);
    return (keys1.length === keys2.length &&
        keys1.every((k) => keyset2.has(k) && cur[k] === prev[k]));
}
/**
 * Compares 2D vectors.
 */
function compareVector2(cur, prev) {
    if (cur === prev)
        return true;
    if (!cur || !prev)
        return false;
    return cur[0] === prev[0] && cur[1] === prev[1];
}

/**
 * Simple helper to accumulate a boolean result.
 */
function useBooleanAccumulator() {
    const valueRef = react.useRef(false);
    const reset = react.useCallback(() => {
        valueRef.current = false;
    }, []);
    const accumulate = react.useCallback((b) => {
        valueRef.current || (valueRef.current = b);
    }, []);
    return [valueRef, accumulate, reset];
}

/**
 * useEffect, but with a custom dependency array comparator.
 *
 * If the comparator returns false, the effect is run.
 */
function useComparableEffect(callback, deps, comparator) {
    const dependencies = react.useRef();
    if (dependencies.current === undefined ||
        !comparator(dependencies.current, deps)) {
        dependencies.current = deps;
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
    react.useEffect(callback, dependencies.current);
}

function useColorTransferFunction(presetName, range, trackModified) {
    const [lutRef, getLUT] = useGetterRef(() => {
        const func = vtkColorTransferFunction__default["default"].newInstance();
        deletionRegistry.register(func, () => func.delete());
        return func;
    });
    useComparableEffect(() => {
        if (!presetName || !range)
            return;
        const lut = getLUT();
        const preset = vtkColorMaps__default["default"].getPresetByName(presetName);
        lut.applyColorMap(preset);
        lut.setMappingRange(range[0], range[1]);
        lut.updateRange();
        trackModified(true);
    }, [presetName, range], ([curPreset, curRange], [oldPreset, oldRange]) => curPreset === oldPreset && compareVector2(curRange, oldRange));
    useUnmount(() => {
        if (lutRef.current) {
            deletionRegistry.markForDeletion(lutRef.current);
            lutRef.current = null;
        }
    });
    return getLUT;
}

function useCoordinate(props, trackModified) {
    const [ref, getCoordinate] = useGetterRef(() => {
        const coord = vtkCoordinate__default["default"].newInstance(props);
        deletionRegistry.register(coord, () => coord.delete());
        return coord;
    });
    useComparableEffect(() => {
        if (!props)
            return;
        getCoordinate().set(props);
        trackModified(true);
    }, [props], ([cur], [prev]) => compareShallowObject(cur, prev));
    useUnmount(() => {
        if (ref.current) {
            deletionRegistry.markForDeletion(ref.current);
            ref.current = null;
        }
    });
    return getCoordinate;
}

/**
 * Returns a mapper getter.
 */
function useMapper(constructor, props, trackModified) {
    const [mapperRef, getMapper] = useGetterRef(() => {
        const m = constructor();
        deletionRegistry.register(m, () => m.delete());
        return m;
    });
    useComparableEffect(() => {
        if (!props)
            return;
        trackModified(getMapper().set(props));
    }, [props], ([cur], [prev]) => compareShallowObject(cur, prev));
    useUnmount(() => {
        if (mapperRef.current) {
            deletionRegistry.markForDeletion(mapperRef.current);
            mapperRef.current = null;
        }
    });
    return getMapper;
}

/**
 * Returns a vtkProp getter.
 *
 * Must be used in an ordered unmount context for
 * proper unmount order.
 */
function useProp({ constructor, id, props, trackModified }) {
    const renderer = useRendererContext();
    const [actorRef, getActor] = useGetterRef(() => {
        const a = constructor();
        deletionRegistry.register(a, () => a.delete());
        return a;
    });
    react.useEffect(() => {
        getActor().set({ representationId: id }, true /* noWarning */);
    }, [id, getActor]);
    // add to renderer
    react.useEffect(() => {
        const actor = getActor();
        const ren = renderer.get();
        deletionRegistry.incRefCount(ren);
        ren.addActor(actor);
        return () => {
            ren.removeActor(actor);
            deletionRegistry.decRefCount(ren);
        };
    }, [renderer, getActor]);
    // set actor props
    useComparableEffect(() => {
        if (!props)
            return;
        trackModified(getActor().set(props));
    }, [props], ([cur], [prev]) => compareShallowObject(cur, prev));
    // cleanup on unmount
    useUnmount(() => {
        if (actorRef.current) {
            deletionRegistry.markForDeletion(actorRef.current);
            actorRef.current = null;
        }
    });
    return getActor;
}

const DefaultProps$7 = {
    colorMapPreset: 'erdc_rainbow_bright',
    colorDataRange: [0, 1],
    transformCoordinate: {
        coordinateSystem: Constants.Coordinate.DISPLAY,
    },
};
var Geometry2DRepresentation = react.forwardRef(function Geometry2DRepresentation(props, fwdRef) {
    var _a, _b, _c, _d;
    const [modifiedRef, trackModified, resetModified] = useBooleanAccumulator();
    const [dataAvailable, setDataAvailable] = react.useState(false);
    // --- LUT --- //
    const getLookupTable = useColorTransferFunction((_a = props.colorMapPreset) !== null && _a !== void 0 ? _a : DefaultProps$7.colorMapPreset, (_b = props.colorDataRange) !== null && _b !== void 0 ? _b : DefaultProps$7.colorDataRange, trackModified);
    // --- coordinate --- //
    const { transformCoordinate = DefaultProps$7.transformCoordinate } = props;
    const getCoordinate = useCoordinate(transformCoordinate, trackModified);
    // --- mapper --- //
    const getMapper = useMapper(() => vtkMapper2D__default["default"].newInstance({
        lookupTable: getLookupTable(),
        useLookupTableScalarRange: false,
        scalarVisibility: false,
        transformCoordinate: getCoordinate(),
    }), props.mapper, trackModified);
    // --- actor --- //
    const actorProps = Object.assign(Object.assign({}, props.actor), { visibility: dataAvailable && ((_d = (_c = props.actor) === null || _c === void 0 ? void 0 : _c.visibility) !== null && _d !== void 0 ? _d : true) });
    const getActor = useProp({
        constructor: () => vtkActor2D__default["default"].newInstance({ visibility: false }),
        id: props.id,
        props: actorProps,
        trackModified,
    });
    react.useEffect(() => {
        // TODO type hack; upgrade vtk.js
        const actor = getActor();
        actor.setMapper(getMapper());
    }, [getActor, getMapper]);
    // set actor property props
    const { property: propertyProps } = props;
    useComparableEffect(() => {
        if (!propertyProps)
            return;
        trackModified(getActor().getProperty().set(propertyProps));
    }, [propertyProps], ([cur], [prev]) => compareShallowObject(cur, prev));
    // --- //
    const renderer = useRendererContext();
    react.useEffect(() => {
        if (modifiedRef.current) {
            renderer.requestRender();
            resetModified();
        }
    });
    const representation = react.useMemo(() => ({
        dataChanged: () => {
            renderer.requestRender();
        },
        dataAvailable: () => {
            setDataAvailable(true);
            representation.dataChanged();
        },
        getActor,
        getMapper,
    }), [renderer, getActor, getMapper]);
    const downstream = react.useMemo(() => ({
        setInputData: (...args) => getMapper().setInputData(...args),
        setInputConnection: (...args) => getMapper().setInputConnection(...args),
    }), [getMapper]);
    react.useImperativeHandle(fwdRef, () => representation);
    return (jsxRuntime.jsx(RepresentationContext.Provider, Object.assign({ value: representation }, { children: jsxRuntime.jsx(DownstreamContext.Provider, Object.assign({ value: downstream }, { children: props.children })) })));
});

const DefaultProps$6 = {
    colorMapPreset: 'erdc_rainbow_bright',
    colorDataRange: [0, 1],
};
var GeometryRepresentation = react.forwardRef(function GeometryRepresentation(props, fwdRef) {
    var _a, _b, _c, _d;
    const [modifiedRef, trackModified, resetModified] = useBooleanAccumulator();
    const [dataAvailable, setDataAvailable] = react.useState(false);
    // --- LUT --- //
    const getLookupTable = useColorTransferFunction((_a = props.colorMapPreset) !== null && _a !== void 0 ? _a : DefaultProps$6.colorMapPreset, (_b = props.colorDataRange) !== null && _b !== void 0 ? _b : DefaultProps$6.colorDataRange, trackModified);
    // --- mapper --- //
    const getMapper = useMapper(() => vtkMapper__default["default"].newInstance({
        lookupTable: getLookupTable(),
        useLookupTableScalarRange: true,
    }), props.mapper, trackModified);
    react.useEffect(() => {
        getMapper().setLookupTable(getLookupTable());
    }, [getMapper, getLookupTable]);
    // --- actor --- //
    const actorProps = Object.assign(Object.assign({}, props.actor), { visibility: dataAvailable && ((_d = (_c = props.actor) === null || _c === void 0 ? void 0 : _c.visibility) !== null && _d !== void 0 ? _d : true) });
    const getActor = useProp({
        constructor: () => vtkActor__default["default"].newInstance({ visibility: false }),
        id: props.id,
        props: actorProps,
        trackModified,
    });
    react.useEffect(() => {
        getActor().setMapper(getMapper());
    }, [getActor, getMapper]);
    // set actor property props
    const { property: propertyProps } = props;
    useComparableEffect(() => {
        if (!propertyProps)
            return;
        trackModified(getActor().getProperty().set(propertyProps));
    }, [propertyProps], ([cur], [prev]) => compareShallowObject(cur, prev));
    // --- //
    const renderer = useRendererContext();
    react.useEffect(() => {
        if (modifiedRef.current) {
            renderer.requestRender();
            resetModified();
        }
    });
    const representation = react.useMemo(() => ({
        dataChanged: () => {
            renderer.requestRender();
        },
        dataAvailable: () => {
            setDataAvailable(true);
            representation.dataChanged();
        },
        getActor,
        getMapper,
    }), [renderer, getActor, getMapper]);
    const downstream = react.useMemo(() => ({
        setInputData: (...args) => getMapper().setInputData(...args),
        setInputConnection: (...args) => getMapper().setInputConnection(...args),
    }), [getMapper]);
    react.useImperativeHandle(fwdRef, () => representation);
    return (jsxRuntime.jsx(RepresentationContext.Provider, Object.assign({ value: representation }, { children: jsxRuntime.jsx(DownstreamContext.Provider, Object.assign({ value: downstream }, { children: props.children })) })));
});

const DefaultProps$5 = {
    port: 0,
    dimensions: [1, 1, 1],
    spacing: [1, 1, 1],
    origin: [0, 0, 0],
    direction: [1, 0, 0, 0, 1, 0, 0, 0, 1],
};
var ImageData = react.forwardRef(function PolyData(props, fwdRef) {
    const { port = DefaultProps$5.port, dimensions = DefaultProps$5.dimensions, spacing = DefaultProps$5.spacing, origin = DefaultProps$5.origin, direction = DefaultProps$5.direction, } = props;
    const [imRef, getImageData] = useGetterRef(() => {
        const im = vtkImageData__default["default"].newInstance();
        deletionRegistry.register(im, () => im.delete());
        return im;
    });
    const representation = useRepresentation();
    const downstream = useDownstream();
    // dataset API
    const dataset = react.useMemo(() => ({
        getDataSet: getImageData,
        modified: () => {
            const im = getImageData();
            im.modified();
            downstream.setInputData(im, port);
            // Let the representation know that we have data
            if (im.getPointData().getScalars().getData()) {
                representation.dataAvailable();
            }
        },
    }), [port, representation, downstream, getImageData]);
    react.useImperativeHandle(fwdRef, () => dataset);
    // --- update image data model --- //
    react.useEffect(() => {
        const imageData = getImageData();
        if (imageData.set({ dimensions, spacing, origin, direction })) {
            dataset.modified();
        }
    }, [dimensions, spacing, origin, direction, dataset, getImageData]);
    useUnmount(() => {
        if (imRef.current) {
            deletionRegistry.markForDeletion(imRef.current);
            imRef.current = null;
        }
    });
    return (jsxRuntime.jsx(DatasetContext.Provider, Object.assign({ value: dataset }, { children: props.children })));
});

const ResizeWatcherContext = react.createContext(null);
/**
 * A variant of ResizeObserver that acts similarly to add/removeEventListener.
 */
class ResizeWatcher {
    constructor() {
        this.resizeObserver = new ResizeObserver((entries) => this.onResize(entries));
        this.callbacks = new Map();
    }
    onResize(entries) {
        entries.forEach((entry) => {
            const callbacks = this.callbacks.get(entry.target);
            if (callbacks) {
                callbacks.forEach((cb) => cb(entry.target));
            }
        });
    }
    watch(element, callback) {
        var _a;
        const cbs = (_a = this.callbacks.get(element)) !== null && _a !== void 0 ? _a : [];
        cbs.push(callback);
        this.callbacks.set(element, cbs);
        this.resizeObserver.observe(element);
    }
    unwatch(element, callback) {
        var _a;
        this.resizeObserver.unobserve(element);
        const cbs = (_a = this.callbacks.get(element)) !== null && _a !== void 0 ? _a : [];
        const idx = cbs.indexOf(callback);
        if (idx > -1) {
            cbs.splice(idx, 1);
        }
    }
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

const RENDERWINDOW_STYLE = {
    position: 'absolute',
    width: '100%',
    height: '100%',
    overflow: 'hidden',
};
var OpenGLRenderWindow = react.forwardRef(function OpenGLRenderWindow(props, fwdRef) {
    const rwContainerRef = react.useRef(null);
    const [viewRef, getRWView] = useGetterRef(() => {
        const view = vtkOpenGLRenderWindow__default["default"].newInstance();
        deletionRegistry.register(view, () => view.delete());
        return view;
    });
    react.useEffect(() => {
        const view = getRWView();
        view.setContainer(rwContainerRef.current);
        return () => {
            // FIXME setContainer API should allow null
            view.setContainer(null);
        };
    }, [getRWView]);
    useUnmount(() => {
        if (viewRef.current) {
            deletionRegistry.markForDeletion(viewRef.current);
            viewRef.current = null;
        }
    });
    const api = react.useMemo(() => ({
        get: getRWView,
        getContainer: () => rwContainerRef.current,
    }), [getRWView]);
    react.useImperativeHandle(fwdRef, () => api);
    const { children, style, renderWindowStyle } = props, containerProps = __rest(props, ["children", "style", "renderWindowStyle"]);
    const containerStyle = react.useMemo(() => (Object.assign({ position: 'relative', width: '100%', height: '100%' }, style)), [style]);
    const rwContainerStyle = react.useMemo(() => (Object.assign(Object.assign({}, RENDERWINDOW_STYLE), renderWindowStyle)), [renderWindowStyle]);
    return (jsxRuntime.jsxs("div", Object.assign({}, containerProps, { style: containerStyle }, { children: [jsxRuntime.jsx("div", { ref: rwContainerRef, style: rwContainerStyle }), jsxRuntime.jsx(OpenGLRenderWindowContext.Provider, Object.assign({ value: api }, { children: children }))] })));
});

function useMount(cb) {
    react.useEffect(() => {
        cb();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
}

function useResizeObserver(el, callback) {
    const cbRef = react.useRef(callback);
    cbRef.current = callback;
    const handleResize = (entry) => cbRef.current(entry);
    const observer = react.useRef(null);
    if (!observer.current) {
        observer.current = new ResizeObserver((entries) => {
            if (entries.length === 1) {
                handleResize(entries[0]);
            }
        });
    }
    react.useEffect(() => {
        const obs = observer.current;
        if (!obs || !el)
            return;
        obs.observe(el);
        return () => {
            obs.unobserve(el);
        };
    }, [el]);
    useUnmount(() => {
        if (observer.current) {
            observer.current.disconnect();
        }
    });
}

function useInteractor(openglRenderWindow) {
    const [interactorRef, getInteractor] = useGetterRef(() => {
        const interactor = vtkRenderWindowInteractor__default["default"].newInstance();
        deletionRegistry.register(interactor, () => interactor.delete());
        return interactor;
    });
    react.useEffect(() => {
        const container = openglRenderWindow.getContainer();
        if (!container)
            return;
        const interactor = getInteractor();
        const rwView = openglRenderWindow.get();
        deletionRegistry.incRefCount(rwView);
        interactor.setView(rwView);
        interactor.initialize();
        interactor.bindEvents(container);
        return () => {
            interactor.disable();
            interactor.unbindEvents();
            deletionRegistry.decRefCount(rwView);
        };
    }, [openglRenderWindow, getInteractor]);
    useUnmount(() => {
        if (interactorRef.current) {
            deletionRegistry.markForDeletion(interactorRef.current);
            interactorRef.current = null;
        }
    });
    return getInteractor;
}

var RenderWindow = react.forwardRef(function RenderWindow(props, fwdRef) {
    const openGLRenderWindow = react.useContext(OpenGLRenderWindowContext);
    if (!openGLRenderWindow)
        throw new Error('No OpenGL Render Window!');
    // --- RenderWindow --- //
    const [rwRef, getRenderWindow] = useGetterRef(() => {
        const rw = vtkRenderWindow__default["default"].newInstance();
        deletionRegistry.register(rw, () => rw.delete());
        return rw;
    });
    react.useEffect(() => {
        const rwView = openGLRenderWindow.get();
        deletionRegistry.incRefCount(rwView);
        const renderWindow = getRenderWindow();
        renderWindow.addView(rwView);
        return () => {
            renderWindow.removeView(rwView);
            deletionRegistry.decRefCount(rwView);
        };
    }, [openGLRenderWindow, getRenderWindow]);
    useUnmount(() => {
        if (rwRef.current) {
            deletionRegistry.markForDeletion(rwRef.current);
            rwRef.current = null;
        }
    });
    // --- Interactor --- //
    const getInteractor = useInteractor(openGLRenderWindow);
    react.useEffect(() => {
        getRenderWindow().setInteractor(getInteractor());
    });
    // --- rendering --- //
    const renderTimeoutRef = react.useRef(null);
    const queueRender = react.useCallback(() => {
        if (renderTimeoutRef.current == null) {
            renderTimeoutRef.current = setTimeout(() => {
                renderTimeoutRef.current = null;
                const renderWindow = getRenderWindow();
                renderWindow.render();
            });
        }
    }, [getRenderWindow]);
    // --- resize --- //
    const updateViewSize = react.useCallback(() => {
        const container = openGLRenderWindow.getContainer();
        if (!container)
            return;
        const renderWindowView = openGLRenderWindow.get();
        const devicePixelRatio = window.devicePixelRatio || 1;
        const { width, height } = container.getBoundingClientRect();
        const w = Math.floor(width * devicePixelRatio);
        const h = Math.floor(height * devicePixelRatio);
        renderWindowView.setSize(Math.max(w, 10), Math.max(h, 10));
        queueRender();
    }, [openGLRenderWindow, queueRender]);
    useResizeObserver(openGLRenderWindow.get().getContainer(), updateViewSize);
    useMount(() => updateViewSize());
    // --- api --- //
    const api = react.useMemo(() => ({
        get: getRenderWindow,
        getInteractor,
        requestRender: queueRender,
    }), [getRenderWindow, getInteractor, queueRender]);
    react.useImperativeHandle(fwdRef, () => api);
    return (jsxRuntime.jsx(RenderWindowContext.Provider, Object.assign({ value: api }, { children: props.children })));
});

const RW_STYLE = {
    pointerEvents: 'none',
};
function MultiViewRoot(props) {
    const openGLRenderWindowRef = react.useRef(null);
    const renderWindowRef = react.useRef(null);
    const resizeWatcherRef = react.useRef(new ResizeWatcher());
    const onResize = react.useCallback((target) => {
        const oglrw = openGLRenderWindowRef.current;
        const rw = renderWindowRef.current;
        if (!oglrw || !rw)
            return;
        const devicePixelRatio = window.devicePixelRatio || 1;
        const { width, height } = target.getBoundingClientRect();
        const w = Math.floor(width * devicePixelRatio);
        const h = Math.floor(height * devicePixelRatio);
        oglrw.get().setSize(Math.max(w, 10), Math.max(h, 10));
        rw.requestRender();
    }, []);
    react.useEffect(() => {
        const oglrw = openGLRenderWindowRef.current;
        const container = oglrw === null || oglrw === void 0 ? void 0 : oglrw.getContainer();
        if (oglrw && container) {
            const resize = resizeWatcherRef.current;
            resize.watch(container, onResize);
            return () => {
                resize.unwatch(container, onResize);
            };
        }
    }, [onResize]);
    return (jsxRuntime.jsx(ResizeWatcherContext.Provider, Object.assign({ value: resizeWatcherRef.current }, { children: jsxRuntime.jsx(MultiViewRootContext.Provider, Object.assign({ value: true }, { children: jsxRuntime.jsx(OpenGLRenderWindow, Object.assign({}, props, { renderWindowStyle: RW_STYLE, ref: openGLRenderWindowRef }, { children: jsxRuntime.jsx(RenderWindow, Object.assign({ ref: renderWindowRef }, { children: props.children })) })) })) })));
}

function useDebounce(fn, threshold) {
    const ref = react.useRef(macros.debounce(fn, threshold));
    react.useEffect(() => {
        ref.current = macros.debounce(fn, threshold);
    }, [fn, threshold]);
    const wrapper = react.useCallback((...args) => ref.current(...args), []);
    return wrapper;
}

function getElementTarget(target) {
    if (typeof target === 'function') {
        return target();
    }
    if (target && 'current' in target) {
        return target.current;
    }
    return target;
}
/**
 * Event Listener.
 *
 * The typing currently only supports HTMLElement targets.
 */
function useEventListener(target, eventName, callback, options) {
    // avoid add/remove listener whenever callback changes
    const cachedCallback = react.useRef(callback);
    react.useEffect(() => {
        cachedCallback.current = callback;
    }, [callback]);
    react.useEffect(() => {
        const el = getElementTarget(target);
        if (el) {
            el.addEventListener(eventName, cachedCallback.current, options);
            return () => {
                el.removeEventListener(eventName, cachedCallback.current, options);
            };
        }
    }, [eventName, options, target]);
}

function useOpenGLHardwareSelector() {
    const [selectorRef, getSelector] = useGetterRef(() => {
        const selector = vtkOpenGLHardwareSelector__default["default"].newInstance({
            captureZValues: true,
        });
        deletionRegistry.register(selector, () => selector.delete());
        return selector;
    });
    useUnmount(() => {
        if (selectorRef.current) {
            deletionRegistry.markForDeletion(selectorRef.current);
            selectorRef.current = null;
        }
    });
    return getSelector;
}
const DefaultProps$4 = {
    enabled: true,
    pointerSize: 0,
    onHoverDebounceWait: 4,
};
var Picking = react.forwardRef(function ViewPicking(props, fwdRef) {
    const openGLRenderWindowAPI = react.useContext(OpenGLRenderWindowContext);
    const rendererAPI = react.useContext(RendererContext);
    const viewAPI = react.useContext(ViewContext);
    if (!openGLRenderWindowAPI || !rendererAPI || !viewAPI) {
        throw new Error('<ViewPicking> must have a <View> ancestor');
    }
    const getSelector = useOpenGLHardwareSelector();
    useMount(() => {
        const selector = getSelector();
        selector.setFieldAssociation(Constants_js.FieldAssociations.FIELD_ASSOCIATION_POINTS);
        selector.attach(openGLRenderWindowAPI.get(), rendererAPI.get());
        return () => {
            // avoids keeping refs to the openglrenderwindow and renderer
            selector.attach(null, null);
        };
    });
    // --- Props --- //
    const { enabled = DefaultProps$4.enabled, pointerSize = DefaultProps$4.pointerSize, } = props;
    const getPointerSizeTolerance = react.useCallback(() => pointerSize / 2, [pointerSize]);
    // --- API --- //
    const pickClosest = react.useCallback((xp, yp, tolerance) => {
        const x1 = Math.floor(xp - tolerance);
        const y1 = Math.floor(yp - tolerance);
        const x2 = Math.ceil(xp + tolerance);
        const y2 = Math.ceil(yp + tolerance);
        const selector = getSelector();
        const openGLRenderWindow = openGLRenderWindowAPI.get();
        const renderer = rendererAPI.get();
        selector.setArea(x1, y1, x2, y2);
        if (!selector.captureBuffers()) {
            return [];
        }
        const pos = [xp, yp];
        const outSelectedPosition = [0, 0];
        const info = selector.getPixelInformation(pos, tolerance, outSelectedPosition);
        if (info == null || info.prop == null)
            return [];
        const startPoint = openGLRenderWindow.displayToWorld(Math.round((x1 + x2) / 2), Math.round((y1 + y2) / 2), 0, renderer);
        const endPoint = openGLRenderWindow.displayToWorld(Math.round((x1 + x2) / 2), Math.round((y1 + y2) / 2), 1, renderer);
        const ray = [Array.from(startPoint), Array.from(endPoint)];
        const worldPosition = Array.from(openGLRenderWindow.displayToWorld(info.displayPosition[0], info.displayPosition[1], info.zValue, renderer));
        const displayPosition = [
            info.displayPosition[0],
            info.displayPosition[1],
            info.zValue,
        ];
        return [
            Object.assign(Object.assign({ worldPosition,
                displayPosition, compositeID: info.compositeID }, info.prop.get('representationId')), { ray }),
        ];
    }, [rendererAPI, openGLRenderWindowAPI, getSelector]);
    const pick = react.useCallback((x1, y1, x2, y2) => {
        const selector = getSelector();
        const openGLRenderWindow = openGLRenderWindowAPI.get();
        const renderer = rendererAPI.get();
        selector.setArea(x1, y1, x2, y2);
        if (!selector.captureBuffers()) {
            return [];
        }
        const ray = [
            Array.from(openGLRenderWindow.displayToWorld(Math.round((x1 + x2) / 2), Math.round((y1 + y2) / 2), 0, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(Math.round((x1 + x2) / 2), Math.round((y1 + y2) / 2), 1, renderer)),
        ];
        const selections = selector.generateSelection(x1, y1, x2, y2) || [];
        return selections
            .map((v) => {
            const { prop, compositeID, displayPosition } = v.getProperties();
            // Return false to mark this item for removal
            if (prop == null || !displayPosition)
                return false;
            return Object.assign(Object.assign({ worldPosition: Array.from(openGLRenderWindow.displayToWorld(displayPosition[0], displayPosition[1], displayPosition[2], renderer)), displayPosition,
                compositeID }, prop.get('representationId')), { ray });
        })
            .filter(Boolean);
    }, [rendererAPI, openGLRenderWindowAPI, getSelector]);
    const pickWithFrustum = react.useCallback((x1, y1, x2, y2) => {
        const selector = getSelector();
        const openGLRenderWindow = openGLRenderWindowAPI.get();
        const renderer = rendererAPI.get();
        selector.setArea(x1, y1, x2, y2);
        if (!selector.captureBuffers()) {
            return null;
        }
        const frustum = [
            Array.from(openGLRenderWindow.displayToWorld(x1, y1, 0, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x2, y1, 0, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x2, y2, 0, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x1, y2, 0, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x1, y1, 1, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x2, y1, 1, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x2, y2, 1, renderer)),
            Array.from(openGLRenderWindow.displayToWorld(x1, y2, 1, renderer)),
        ];
        const representationIds = [];
        const selections = selector.generateSelection(x1, y1, x2, y2) || [];
        selections.forEach((v) => {
            const { prop } = v.getProperties();
            const getterResult = prop === null || prop === void 0 ? void 0 : prop.get('representationId');
            const representationId = getterResult === null || getterResult === void 0 ? void 0 : getterResult.representationId;
            if (representationId) {
                representationIds.push(representationId);
            }
        });
        return { frustum, representationIds };
    }, [rendererAPI, openGLRenderWindowAPI, getSelector]);
    const api = react.useMemo(() => ({
        pick,
        pickWithFrustum,
        pickClosest,
    }), [pick, pickWithFrustum, pickClosest]);
    react.useImperativeHandle(fwdRef, () => api);
    // --- Pointer event handling --- //
    const getScreenEventPositionFor = react.useCallback((source) => {
        const rw = openGLRenderWindowAPI.get();
        const canvas = rw.getCanvas();
        if (!canvas)
            return { x: 0, y: 0, z: 0 };
        const bounds = canvas.getBoundingClientRect();
        const [canvasWidth, canvasHeight] = rw.getSize();
        const scaleX = canvasWidth / bounds.width;
        const scaleY = canvasHeight / bounds.height;
        const position = {
            x: scaleX * (source.clientX - bounds.left),
            y: scaleY * (bounds.height - source.clientY + bounds.top),
            z: 0,
        };
        return position;
    }, [openGLRenderWindowAPI]);
    const { onHover, onPointerDown, onPointerUp, onClick } = props;
    const makeSelection = react.useCallback((ev) => {
        const { x, y } = getScreenEventPositionFor(ev);
        const tolerance = getPointerSizeTolerance();
        const selections = pickClosest(Math.floor(x), Math.floor(y), tolerance);
        return selections[0];
    }, [getScreenEventPositionFor, getPointerSizeTolerance, pickClosest]);
    // --- register event handlers --- //
    const { onHoverDebounceWait = DefaultProps$4.onHoverDebounceWait } = props;
    // TODO last selection? (see View.js)
    useEventListener(viewAPI.getViewContainer, 'pointermove', useDebounce(react.useCallback((ev) => {
        if (!enabled || !onHover)
            return;
        onHover(makeSelection(ev), ev);
    }, [makeSelection, onHover, enabled]), onHoverDebounceWait));
    useEventListener(viewAPI.getViewContainer, 'pointerdown', react.useCallback((ev) => {
        if (!enabled || !onPointerDown)
            return;
        onPointerDown(makeSelection(ev), ev);
    }, [makeSelection, onPointerDown, enabled]));
    useEventListener(viewAPI.getViewContainer, 'pointerup', react.useCallback((ev) => {
        if (!enabled || !onPointerUp)
            return;
        onPointerUp(makeSelection(ev), ev);
    }, [makeSelection, onPointerUp, enabled]));
    useEventListener(viewAPI.getViewContainer, 'click', react.useCallback((ev) => {
        if (!enabled || !onClick)
            return;
        onClick(makeSelection(ev), ev);
    }, [makeSelection, onClick, enabled]));
    return null;
});

function PointData(props) {
    const dataset = useDataset();
    const getPointData = react.useCallback(() => {
        return dataset.getDataSet().getPointData();
    }, [dataset]);
    return (jsxRuntime.jsx(FieldDataContext.Provider, Object.assign({ value: getPointData }, { children: props.children })));
}

const DefaultProps$3 = {
    port: 0,
    points: [],
    connectivity: 'manual',
};
var PolyData = react.forwardRef(function PolyData(props, fwdRef) {
    const { port = DefaultProps$3.port, points = DefaultProps$3.points, connectivity = DefaultProps$3.connectivity, verts, lines, polys, strips, } = props;
    const [pdRef, getPolyData] = useGetterRef(() => {
        const pd = vtkPolyData__default["default"].newInstance();
        deletionRegistry.register(pd, () => pd.delete());
        return pd;
    });
    const representation = useRepresentation();
    const downstream = useDownstream();
    // dataset API
    const dataset = react.useMemo(() => ({
        getDataSet: getPolyData,
        modified: () => {
            const pd = getPolyData();
            pd.modified();
            downstream.setInputData(pd, port);
            // Let the representation know that we have data
            if (pd.getPoints().getData()) {
                representation.dataAvailable();
            }
        },
    }), [port, representation, downstream, getPolyData]);
    react.useImperativeHandle(fwdRef, () => dataset);
    const prev = usePrevious(Object.assign(Object.assign({}, DefaultProps$3), props));
    // update polydata
    react.useEffect(() => {
        const polyData = getPolyData();
        let modified = !prev;
        let typedArrayClass = Uint32Array;
        // TODO shallow array equals? Or tell developer to do this?
        if (points && points !== (prev === null || prev === void 0 ? void 0 : prev.points)) {
            modified = true;
            const array = toTypedArray(points, Float64Array);
            polyData.getPoints().setData(array, 3);
            // Adapt cell size
            // Max cell size for uint16 is 655356*3=196608.
            // switch to uint32array if this is the case.
            typedArrayClass = array.length > 196608 ? Uint32Array : Uint16Array;
        }
        if (verts && verts !== (prev === null || prev === void 0 ? void 0 : prev.verts)) {
            modified = true;
            polyData.getVerts().setData(toTypedArray(verts, typedArrayClass));
        }
        if (lines && lines !== (prev === null || prev === void 0 ? void 0 : prev.lines)) {
            modified = true;
            polyData.getLines().setData(toTypedArray(lines, typedArrayClass));
        }
        if (polys && polys !== (prev === null || prev === void 0 ? void 0 : prev.polys)) {
            modified = true;
            polyData.getPolys().setData(toTypedArray(polys, typedArrayClass));
        }
        if (strips && strips !== (prev === null || prev === void 0 ? void 0 : prev.strips)) {
            modified = true;
            polyData.getStrips().setData(toTypedArray(strips, typedArrayClass));
        }
        const curSize = dataArraySize(points);
        const prevSize = (prev === null || prev === void 0 ? void 0 : prev.points) ? dataArraySize(prev.points) : NaN;
        if (connectivity !== (prev === null || prev === void 0 ? void 0 : prev.connectivity) || curSize !== prevSize) {
            modified = true;
            const nbPoints = curSize / 3;
            switch (connectivity) {
                case 'points':
                    {
                        const values = new Uint32Array(nbPoints + 1);
                        values[0] = nbPoints;
                        for (let i = 0; i < nbPoints; i++) {
                            values[i + 1] = i;
                        }
                        polyData.getVerts().setData(values);
                    }
                    break;
                case 'triangles':
                    {
                        const values = new Uint32Array(nbPoints + nbPoints / 3);
                        let offset = 0;
                        for (let i = 0; i < nbPoints; i += 3) {
                            values[offset++] = 3;
                            values[offset++] = i + 0;
                            values[offset++] = i + 1;
                            values[offset++] = i + 2;
                        }
                        polyData.getPolys().setData(values);
                    }
                    break;
                case 'strips':
                    {
                        const values = new Uint32Array(nbPoints + 1);
                        values[0] = nbPoints;
                        for (let i = 0; i < nbPoints; i++) {
                            values[i + 1] = i;
                        }
                        polyData.getStrips().setData(values);
                    }
                    break;
                // do nothing for manual or anything else...
            }
        }
        if (modified) {
            polyData.computeBounds();
            dataset.modified();
        }
    });
    useUnmount(() => {
        if (pdRef.current) {
            deletionRegistry.markForDeletion(pdRef.current);
            pdRef.current = null;
        }
    });
    return (jsxRuntime.jsx(DatasetContext.Provider, Object.assign({ value: dataset }, { children: props.children })));
});

/**
 * Reads data and produces vtkObjects.
 */
function Reader(props) {
    const { vtkClass, url, urlOptions, arrayBuffer, base64ArrayBuffer, text } = props;
    if ([url, arrayBuffer, base64ArrayBuffer, text].filter(Boolean).length > 1) {
        console.warn('<Reader>: multiple data options provided. Please only provide one.');
    }
    const representation = useRepresentation();
    const createReader = react.useCallback(() => {
        if (typeof vtkClass === 'string') {
            return vtk__default["default"]({ vtkClass });
        }
        return vtkClass.newInstance();
    }, [vtkClass]);
    // --- reader creation --- //
    const readerRef = react.useRef(null);
    react.useEffect(() => {
        const reader = createReader();
        deletionRegistry.register(reader, () => reader.delete());
        readerRef.current = reader;
        return () => {
            deletionRegistry.markForDeletion(reader);
        };
    }, [createReader]);
    // --- url handling --- //
    react.useEffect(() => {
        const reader = readerRef.current;
        if (!reader || !url)
            return;
        reader.setUrl(url, urlOptions).then(() => {
            if (reader.isDeleted())
                return;
            representation.dataAvailable();
        });
    }, [url, urlOptions, representation]);
    // --- arrayBuffer --- //
    react.useEffect(() => {
        const reader = readerRef.current;
        if (!reader || !arrayBuffer)
            return;
        reader.parseAsArrayBuffer(arrayBuffer);
        representation.dataAvailable();
    }, [arrayBuffer, representation]);
    // --- base64 string of ArrayBuffer --- //
    react.useEffect(() => {
        const reader = readerRef.current;
        if (!reader || !base64ArrayBuffer)
            return;
        reader.parseAsArrayBuffer(Base64_js.toArrayBuffer(base64ArrayBuffer));
        representation.dataAvailable();
    }, [base64ArrayBuffer, representation]);
    // --- text --- //
    react.useEffect(() => {
        const reader = readerRef.current;
        if (!reader || !text)
            return;
        reader.parseAsText(text);
        representation.dataAvailable();
    }, [text, representation]);
    // --- downstream registration --- //
    const downstream = useDownstream();
    const { port } = props;
    react.useEffect(() => {
        const reader = readerRef.current;
        if (!reader)
            return;
        downstream.setInputConnection(reader.getOutputPort(), port);
    });
}

const DATA_AVAILABLE_EVENT = 'dataAvailable';
const DATA_CHANGED_EVENT = 'dataChanged';
function ShareDataSetRoot(props) {
    const datasets = react.useRef(new Map());
    const eventTarget = react.useRef(new EventTarget());
    // Used to notify UseDataSet components that register
    // after the DATA_AVAILABLE_EVENT occurs.
    const dataAvailable = react.useRef(new Set());
    useUnmount(() => {
        datasets.current.clear();
        dataAvailable.current.clear();
    });
    const createDataEventRegistrar = react.useCallback((event, options) => {
        return function addListener(name, callback) {
            const invoke = () => {
                var _a;
                callback((_a = datasets.current.get(name)) !== null && _a !== void 0 ? _a : null);
            };
            const handler = (ev) => {
                var _a;
                if (!(ev instanceof (CustomEvent)))
                    return;
                if (name === ((_a = ev.detail) === null || _a === void 0 ? void 0 : _a.name)) {
                    invoke();
                }
            };
            let immediate = false;
            if (typeof (options === null || options === void 0 ? void 0 : options.immediate) === 'boolean') {
                immediate = options.immediate;
            }
            else if ((options === null || options === void 0 ? void 0 : options.immediate) instanceof Function) {
                immediate = options === null || options === void 0 ? void 0 : options.immediate(name);
            }
            if (immediate) {
                invoke();
            }
            eventTarget.current.addEventListener(event, handler);
            return () => {
                eventTarget.current.removeEventListener(event, handler);
            };
        };
    }, []);
    const share = react.useMemo(() => ({
        register(name, dataset) {
            datasets.current.set(name, dataset);
        },
        unregister(name) {
            datasets.current.delete(name);
            dataAvailable.current.delete(name);
        },
        dispatchDataAvailable(name) {
            dataAvailable.current.add(name);
            eventTarget.current.dispatchEvent(new CustomEvent(DATA_AVAILABLE_EVENT, {
                detail: { name },
            }));
        },
        dispatchDataChanged(name) {
            eventTarget.current.dispatchEvent(new CustomEvent(DATA_CHANGED_EVENT, {
                detail: { name },
            }));
        },
        onDataChanged: createDataEventRegistrar(DATA_CHANGED_EVENT),
        onDataAvailable: createDataEventRegistrar(DATA_AVAILABLE_EVENT, {
            immediate(name) {
                return dataAvailable.current.has(name);
            },
        }),
    }), [createDataEventRegistrar]);
    return (jsxRuntime.jsx(ShareDataSetContext.Provider, Object.assign({ value: share }, { children: props.children })));
}
function RegisterDataSet(props) {
    const share = useShareDataSet();
    const { id } = props;
    // --- handle registrations --- //
    react.useEffect(() => () => {
        share.unregister(id);
    }, [id, share]);
    useUnmount(() => {
        share.unregister(id);
    });
    // --- //
    const downstream = react.useMemo(() => ({
        setInputData(obj) {
            share.register(id, obj);
        },
        setInputConnection(conn) {
            downstream.setInputData(conn());
        },
    }), [id, share]);
    const mockRepresentation = react.useMemo(() => ({
        dataChanged() {
            share.dispatchDataChanged(id);
        },
        dataAvailable() {
            share.dispatchDataAvailable(id);
        },
        getActor: () => null,
        getMapper: () => null,
    }), [id, share]);
    return (jsxRuntime.jsx(RepresentationContext.Provider, Object.assign({ value: mockRepresentation }, { children: jsxRuntime.jsx(DownstreamContext.Provider, Object.assign({ value: downstream }, { children: props.children })) })));
}
function UseDataSet(props) {
    const { id, port = 0 } = props;
    const share = useShareDataSet();
    // TODO if useDataSet is input to an algorithm, should representation be null?
    const representation = useRepresentation();
    const downstream = useDownstream();
    react.useEffect(() => {
        return share.onDataAvailable(id, (ds) => {
            downstream.setInputData(ds, port);
            representation.dataAvailable();
        });
    }, [id, port, representation, downstream, share]);
    react.useEffect(() => {
        return share.onDataChanged(id, () => {
            representation.dataChanged();
        });
    }, [id, representation, share]);
    return null;
}

const DefaultProps$2 = {
    colorMapPreset: 'Grayscale',
    colorDataRange: 'auto',
};
var SliceRepresentation = react.forwardRef(function SliceRepresentation(props, fwdRef) {
    var _a, _b, _c, _d;
    const [modifiedRef, trackModified, resetModified] = useBooleanAccumulator();
    const [dataAvailable, setDataAvailable] = react.useState(false);
    const rangeFromProps = (_a = props.colorDataRange) !== null && _a !== void 0 ? _a : DefaultProps$2.colorDataRange;
    const colorDataRange = rangeFromProps === 'auto' ? [0, 1] : rangeFromProps;
    // --- LUT --- //
    const getLookupTable = useColorTransferFunction((_b = props.colorMapPreset) !== null && _b !== void 0 ? _b : DefaultProps$2.colorMapPreset, colorDataRange, trackModified);
    // --- PWF --- //
    // --- mapper --- //
    const getMapper = useMapper(() => vtkImageMapper__default["default"].newInstance(), props.mapper, trackModified);
    // --- actor --- //
    const actorProps = Object.assign(Object.assign({}, props.actor), { visibility: dataAvailable && ((_d = (_c = props.actor) === null || _c === void 0 ? void 0 : _c.visibility) !== null && _d !== void 0 ? _d : true) });
    const getActor = useProp({
        constructor: () => vtkImageSlice__default["default"].newInstance(),
        id: props.id,
        props: actorProps,
        trackModified,
    });
    react.useEffect(() => {
        getActor().setMapper(getMapper());
    }, [getActor, getMapper]);
    react.useEffect(() => {
        getActor().getProperty().setRGBTransferFunction(0, getLookupTable());
        getActor().getProperty().setInterpolationTypeToLinear();
    }, [getActor, getLookupTable]);
    // set actor property props
    const { property: propertyProps } = props;
    useComparableEffect(() => {
        if (!propertyProps)
            return;
        trackModified(getActor().getProperty().set(propertyProps));
    }, [propertyProps], ([cur], [prev]) => compareShallowObject(cur, prev));
    // --- Slice changes --- //
    const { iSlice, jSlice, kSlice, xSlice, ySlice, zSlice } = props;
    react.useEffect(() => {
        if (iSlice != null)
            trackModified(getMapper().setISlice(iSlice));
    }, [iSlice, getMapper, trackModified]);
    react.useEffect(() => {
        if (jSlice != null)
            trackModified(getMapper().setJSlice(jSlice));
    }, [jSlice, getMapper, trackModified]);
    react.useEffect(() => {
        if (kSlice != null)
            trackModified(getMapper().setKSlice(kSlice));
    }, [kSlice, getMapper, trackModified]);
    react.useEffect(() => {
        if (xSlice != null)
            trackModified(getMapper().setXSlice(xSlice));
    }, [xSlice, getMapper, trackModified]);
    react.useEffect(() => {
        if (ySlice != null)
            trackModified(getMapper().setYSlice(ySlice));
    }, [ySlice, getMapper, trackModified]);
    react.useEffect(() => {
        if (zSlice != null)
            trackModified(getMapper().setZSlice(zSlice));
    }, [zSlice, getMapper, trackModified]);
    // --- //
    const renderer = useRendererContext();
    react.useEffect(() => {
        if (modifiedRef.current) {
            renderer.requestRender();
            resetModified();
        }
    });
    const representation = react.useMemo(() => ({
        dataChanged: () => {
            renderer.requestRender();
        },
        dataAvailable: () => {
            setDataAvailable(true);
            representation.dataChanged();
        },
        getActor,
        getMapper,
    }), [renderer, getActor, getMapper]);
    const downstream = react.useMemo(() => ({
        setInputData: (...args) => getMapper().setInputData(...args),
        setInputConnection: (...args) => getMapper().setInputConnection(...args),
    }), [getMapper]);
    react.useImperativeHandle(fwdRef, () => representation);
    return (jsxRuntime.jsx(RepresentationContext.Provider, Object.assign({ value: representation }, { children: jsxRuntime.jsx(DownstreamContext.Provider, Object.assign({ value: downstream }, { children: props.children })) })));
});

function useApplyCenterOfRotation(rendererRef, getInteractorStyle, autoCenterOfRotation) {
    // This runs every react render, since I'm not sure what deps would
    // trigger whenever the underlying renderer changes.
    react.useEffect(() => {
        const ren = rendererRef.current;
        if (!ren)
            return;
        const sub = ren.get().onEvent((ev) => {
            const rendererEvent = ev;
            if (rendererEvent.type === 'ResetCameraEvent') {
                const style = getInteractorStyle();
                if (!autoCenterOfRotation || !style.setCenterOfRotation) {
                    return;
                }
                const center = rendererEvent.renderer.getActiveCamera().getFocalPoint();
                style.setCenterOfRotation(center);
            }
        });
        return () => {
            sub.unsubscribe();
        };
    });
}

const settingToManipulator = (setting) => {
    switch (setting.action) {
        case 'Pan':
            return vtkMouseCameraTrackballPanManipulator__default["default"].newInstance(setting);
        case 'Zoom':
            return vtkMouseCameraTrackballZoomManipulator__default["default"].newInstance(setting);
        case 'Roll':
            return vtkMouseCameraTrackballRollManipulator__default["default"].newInstance(setting);
        case 'Rotate':
            return vtkMouseCameraTrackballRotateManipulator__default["default"].newInstance(setting);
        case 'MultiRotate':
            return vtkMouseCameraTrackballMultiRotateManipulator__default["default"].newInstance(setting);
        case 'ZoomToMouse':
            return vtkMouseCameraTrackballZoomToMouseManipulator__default["default"].newInstance(setting);
        case 'Select':
            return vtkMouseBoxSelectorManipulator__default["default"].newInstance(setting);
    }
};
function useInteractorStyleManipulatorSettings(getStyle, settings) {
    useComparableEffect(() => {
        if (!getStyle().isA('vtkInteractorStyleManipulator'))
            return;
        const style = getStyle();
        style.removeAllManipulators();
        // always add gestures
        style.addGestureManipulator(vtkGestureCameraManipulator__default["default"].newInstance());
        settings.forEach((setting) => {
            const manip = settingToManipulator(setting);
            // TODO on box select change
            style.addMouseManipulator(manip);
        });
    }, [settings], ([cur], [prev]) => deepEqual__default["default"](cur, prev));
}
function useInteractorStyle(getInteractor) {
    /**
     * internalStyle: self-managed InteractorStyleManipulator
     * externalStyle: user-set style
     *   - The external style takes precedence over the internal style in getStyle().
     *
     * In a parented view, the style gets set on the interactor whenever
     *   the user hovers over the view.
     * In a single view, the style gets set unconditionally.
     *
     * If the external style is updated:
     *   Single view: set it on the interactor unconditionally
     *   Parented view: set it on the interactor if the previous style
     *     is currently registered to the interactor.
     */
    const [internalStyleRef, getInternalStyle] = useGetterRef(() => {
        const style = vtkInteractorStyleManipulator__default["default"].newInstance();
        deletionRegistry.register(style, () => style.delete());
        return style;
    });
    const externalStyleRef = react.useRef(null);
    const getStyle = react.useCallback(() => {
        var _a;
        return (_a = externalStyleRef.current) !== null && _a !== void 0 ? _a : getInternalStyle();
    }, [getInternalStyle]);
    const setStyle = react.useCallback((style) => {
        const currentStyle = getStyle();
        const interactor = getInteractor();
        if (!interactor)
            return;
        // Single view: always true
        // Parented view: true if we've hovered over the View
        const isCurrentlySet = interactor.getInteractorStyle() === currentStyle;
        if (isCurrentlySet) {
            interactor.setInteractorStyle(style);
        }
        externalStyleRef.current = style;
    }, [getInteractor, getStyle]);
    react.useEffect(() => {
        const interactor = getInteractor();
        if (!interactor)
            return;
        deletionRegistry.incRefCount(interactor);
        return () => {
            if (interactor.getInteractorStyle() === getStyle()) {
                interactor.setInteractorStyle(null);
            }
            deletionRegistry.decRefCount(interactor);
            deletionRegistry.markForDeletion(internalStyleRef.current);
            internalStyleRef.current = null;
        };
    }, [getInteractor, getStyle, internalStyleRef]);
    return [getStyle, setStyle];
}

function useCamera(getRenderer, cameraProps, trackModified) {
    const getCamera = react.useCallback(() => getRenderer().getActiveCamera(), [getRenderer]);
    useComparableEffect(() => {
        if (!cameraProps)
            return;
        const camera = getCamera();
        const mtime = camera.getMTime();
        // filter out any null props
        Object.keys(cameraProps).forEach((key) => {
            const name = key;
            if (!cameraProps[name]) {
                delete cameraProps[name];
            }
        });
        camera.set(cameraProps);
        // force-set focal point and direction of projection,
        // as setting the position changes the focal point and dop
        if (cameraProps.directionOfProjection) {
            camera.setDirectionOfProjection(...cameraProps.directionOfProjection);
        }
        if (cameraProps.focalPoint) {
            camera.setFocalPoint(...cameraProps.focalPoint);
        }
        // camera.set doesn't return whether a change occurred,
        // since setPosition/etc. don't return this flag.
        trackModified(mtime < camera.getMTime());
    }, [cameraProps], ([cur], [prev]) => compareShallowObject(cur, prev));
    return getCamera;
}

const DefaultProps$1 = {
    background: [0.2, 0.3, 0.4],
    interactive: true,
    autoResetCamera: true,
};
var Renderer = react.forwardRef(function Renderer(props, fwdRef) {
    const renderWindow = useRenderWindowContext();
    const [modifiedRef, trackModified, resetModified] = useBooleanAccumulator();
    const [renRef, getRenderer] = useGetterRef(() => {
        const ren = vtkRenderer__default["default"].newInstance();
        deletionRegistry.register(ren, () => ren.delete());
        return ren;
    });
    const { background = DefaultProps$1.background, interactive = DefaultProps$1.interactive, } = props;
    react.useEffect(() => {
        getRenderer().setBackground(background);
    }, [background, getRenderer]);
    react.useEffect(() => {
        getRenderer().setInteractive(interactive);
    }, [interactive, getRenderer]);
    react.useEffect(() => {
        const rw = renderWindow.get();
        deletionRegistry.incRefCount(rw);
        const renderer = getRenderer();
        rw.addRenderer(renderer);
        return () => {
            rw.removeRenderer(renderer);
            deletionRegistry.decRefCount(rw);
        };
    }, [renderWindow, getRenderer]);
    // --- camera --- //
    const { camera: cameraProps, autoResetCamera = DefaultProps$1.autoResetCamera, } = props;
    useCamera(getRenderer, cameraProps, trackModified);
    const resetCamera = react.useCallback((boundsToUse) => {
        getRenderer().resetCamera(boundsToUse);
    }, [getRenderer]);
    // --- cleanup --- //
    useUnmount(() => {
        if (renRef.current) {
            deletionRegistry.markForDeletion(renRef.current);
            renRef.current = null;
        }
    });
    // --- api --- //
    const api = react.useMemo(() => ({
        get: getRenderer,
        resetCamera,
        requestRender: () => {
            if (autoResetCamera) {
                resetCamera();
            }
            renderWindow.requestRender();
        },
    }), [autoResetCamera, renderWindow, resetCamera, getRenderer]);
    react.useEffect(() => {
        if (modifiedRef.current) {
            api.requestRender();
            resetModified();
        }
    });
    react.useImperativeHandle(fwdRef, () => api);
    return (jsxRuntime.jsx(RendererContext.Provider, Object.assign({ value: api }, { children: props.children })));
});

const DefaultProps = {
    interactorSettings: [
        {
            button: 1,
            action: 'Rotate',
        },
        {
            button: 2,
            action: 'Pan',
        },
        {
            button: 3,
            action: 'Zoom',
            scrollEnabled: true,
        },
        {
            button: 1,
            action: 'Pan',
            alt: true,
        },
        {
            button: 1,
            action: 'Zoom',
            control: true,
        },
        {
            button: 1,
            action: 'Select',
            shift: true,
        },
        {
            button: 1,
            action: 'Roll',
            alt: true,
            shift: true,
        },
    ],
    autoCenterOfRotation: true,
};

/**
 * A View that is within a MultiViewRoot.
 */
const ParentedView = react.forwardRef(function ParentedView(props, fwdRef) {
    const containerRef = react.useRef(null);
    const rendererRef = react.useRef(null);
    const rendererProps = pick(props, 'background', 'interactive', 'camera', 'autoResetCamera');
    const openGLRenderWindowAPI = react.useContext(OpenGLRenderWindowContext);
    if (!openGLRenderWindowAPI) {
        throw new Error('OpenGLRenderWindow is missing inside the MultiViewRoot');
    }
    const renderWindowAPI = react.useContext(RenderWindowContext);
    if (!renderWindowAPI) {
        throw new Error('RenderWindow is missing inside the MultiViewRoot');
    }
    // --- interactor & style binding --- //
    const getInteractor = react.useCallback(() => renderWindowAPI.getInteractor(), [renderWindowAPI]);
    const [getInteractorStyle, setInteractorStyle] = useInteractorStyle(getInteractor);
    const { interactorSettings = DefaultProps.interactorSettings, autoCenterOfRotation = DefaultProps.autoCenterOfRotation, } = props;
    useInteractorStyleManipulatorSettings(getInteractorStyle, interactorSettings);
    useApplyCenterOfRotation(rendererRef, getInteractorStyle, autoCenterOfRotation);
    /**
     * 1. Switch to targeted renderer.
     * 2. Switch to this View's interactor style.
     */
    useEventListener(containerRef, 'pointerenter', (ev) => {
        const rendererAPI = rendererRef.current;
        if (!rendererAPI)
            return;
        const interactor = getInteractor();
        interactor.setCurrentRenderer(rendererAPI.get());
        interactor.setInteractorStyle(getInteractorStyle());
        const oldContainer = interactor.getContainer();
        const newContainer = containerRef.current;
        if (oldContainer !== newContainer) {
            if (oldContainer) {
                interactor.unbindEvents();
            }
            if (newContainer) {
                interactor.bindEvents(newContainer);
            }
            // forward event to interactor
            interactor.handlePointerEnter(ev);
        }
    });
    // --- resize handling --- //
    const resizeWatcher = react.useContext(ResizeWatcherContext);
    const onResize = react.useCallback(() => {
        const renderer = rendererRef.current;
        const viewContainer = openGLRenderWindowAPI.getContainer();
        const rendererContainer = containerRef.current;
        if (!renderer || !viewContainer || !rendererContainer)
            return;
        const viewBox = viewContainer.getBoundingClientRect();
        const rendererBox = rendererContainer.getBoundingClientRect();
        const top = rendererBox.top - viewBox.top;
        const left = rendererBox.left - viewBox.left;
        const xmin = left / viewBox.width;
        const xmax = (left + rendererBox.width) / viewBox.width;
        const ymin = 1 - (top + rendererBox.height) / viewBox.height;
        const ymax = 1 - top / viewBox.height;
        renderer.get().setViewport(xmin, ymin, xmax, ymax);
        renderer.requestRender();
    }, [openGLRenderWindowAPI]);
    useMount(() => onResize());
    react.useEffect(() => {
        const rendererContainer = containerRef.current;
        const renderer = rendererRef.current;
        const viewContainer = openGLRenderWindowAPI.getContainer();
        if (resizeWatcher && rendererContainer && renderer && viewContainer) {
            resizeWatcher.watch(rendererContainer, onResize);
            resizeWatcher.watch(viewContainer, onResize);
            return () => {
                resizeWatcher.unwatch(rendererContainer, onResize);
                resizeWatcher.unwatch(viewContainer, onResize);
            };
        }
    }, [onResize, openGLRenderWindowAPI, resizeWatcher]);
    // --- api --- //
    const api = react.useMemo(() => ({
        isInMultiViewRoot: () => true,
        getViewContainer: () => containerRef.current,
        getOpenGLRenderWindow: () => openGLRenderWindowAPI,
        getRenderWindow: () => renderWindowAPI,
        getRenderer: () => rendererRef.current,
        getInteractorStyle: () => getInteractorStyle(),
        setInteractorStyle: (style) => setInteractorStyle(style),
        requestRender: () => { var _a; return (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.requestRender(); },
        getCamera: () => { var _a, _b; return (_b = (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.get().getActiveCamera()) !== null && _b !== void 0 ? _b : null; },
        resetCamera: (boundsToUse) => { var _a; return (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.resetCamera(boundsToUse); },
    }), [
        openGLRenderWindowAPI,
        renderWindowAPI,
        getInteractorStyle,
        setInteractorStyle,
    ]);
    react.useImperativeHandle(fwdRef, () => api);
    const style = react.useMemo(() => ({
        position: 'relative',
        width: '100%',
        height: '100%',
        overflow: 'hidden',
        touchAction: 'none',
        userSelect: 'none',
        WebkitTapHighlightColor: 'rgba(0, 0, 0, 0)',
    }), []);
    return (jsxRuntime.jsx(ViewContext.Provider, Object.assign({ value: api }, { children: jsxRuntime.jsx("div", Object.assign({ style: style, ref: containerRef }, { children: jsxRuntime.jsx(Renderer, Object.assign({}, rendererProps, { ref: rendererRef }, { children: props.children })) })) })));
});

/**
 * A standalone View (not within a MultiViewRoot).
 */
const SingleView = react.forwardRef(function SingleView(props, fwdRef) {
    // view API just exposes the render window + renderer
    const openGLRenderWindowRef = react.useRef(null);
    const renderWindowRef = react.useRef(null);
    const rendererRef = react.useRef(null);
    const rendererProps = pick(props, 'background', 'interactive', 'camera', 'autoResetCamera');
    const openGLRenderWindowProps = omit(props, ...[...Object.keys(rendererProps)]);
    // --- interactor style --- //
    const getInteractor = react.useCallback(() => { var _a, _b; return (_b = (_a = renderWindowRef.current) === null || _a === void 0 ? void 0 : _a.getInteractor()) !== null && _b !== void 0 ? _b : null; }, []);
    const [getInteractorStyle, setInteractorStyle] = useInteractorStyle(getInteractor);
    useMount(() => {
        var _a;
        (_a = getInteractor()) === null || _a === void 0 ? void 0 : _a.setInteractorStyle(getInteractorStyle());
    });
    const { interactorSettings = DefaultProps.interactorSettings, autoCenterOfRotation = DefaultProps.autoCenterOfRotation, } = props;
    useInteractorStyleManipulatorSettings(getInteractorStyle, interactorSettings);
    useApplyCenterOfRotation(rendererRef, getInteractorStyle, autoCenterOfRotation);
    // --- api --- //
    const api = react.useMemo(() => ({
        isInMultiViewRoot: () => false,
        getViewContainer: () => { var _a, _b; return (_b = (_a = openGLRenderWindowRef.current) === null || _a === void 0 ? void 0 : _a.getContainer()) !== null && _b !== void 0 ? _b : null; },
        getOpenGLRenderWindow: () => openGLRenderWindowRef.current,
        getRenderWindow: () => renderWindowRef.current,
        getRenderer: () => rendererRef.current,
        getInteractorStyle: () => getInteractorStyle(),
        setInteractorStyle: (style) => setInteractorStyle(style),
        requestRender: () => { var _a; return (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.requestRender(); },
        getCamera: () => { var _a, _b; return (_b = (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.get().getActiveCamera()) !== null && _b !== void 0 ? _b : null; },
        resetCamera: (boundsToUse) => { var _a; return (_a = rendererRef.current) === null || _a === void 0 ? void 0 : _a.resetCamera(boundsToUse); },
    }), [getInteractorStyle, setInteractorStyle]);
    react.useImperativeHandle(fwdRef, () => api);
    return (jsxRuntime.jsx(ViewContext.Provider, Object.assign({ value: api }, { children: jsxRuntime.jsx(OpenGLRenderWindow, Object.assign({}, openGLRenderWindowProps, { ref: openGLRenderWindowRef }, { children: jsxRuntime.jsx(RenderWindow, Object.assign({ ref: renderWindowRef }, { children: jsxRuntime.jsx(Renderer, Object.assign({}, rendererProps, { ref: rendererRef }, { children: props.children })) })) })) })));
});

var View = react.forwardRef(function View(props, fwdRef) {
    const singleViewRef = react.useRef(null);
    const parentedViewRef = react.useRef(null);
    const multiViewRoot = react.useContext(MultiViewRootContext);
    const api = react.useMemo(() => {
        const getView = () => multiViewRoot ? parentedViewRef.current : singleViewRef.current;
        return {
            isInMultiViewRoot: () => multiViewRoot,
            getViewContainer: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getViewContainer()) !== null && _b !== void 0 ? _b : null; },
            getOpenGLRenderWindow: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getOpenGLRenderWindow()) !== null && _b !== void 0 ? _b : null; },
            getRenderWindow: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getRenderWindow()) !== null && _b !== void 0 ? _b : null; },
            getRenderer: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getRenderer()) !== null && _b !== void 0 ? _b : null; },
            getInteractorStyle: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getInteractorStyle()) !== null && _b !== void 0 ? _b : null; },
            setInteractorStyle: (style) => { var _a; return (_a = getView()) === null || _a === void 0 ? void 0 : _a.setInteractorStyle(style); },
            requestRender: () => { var _a; return (_a = getView()) === null || _a === void 0 ? void 0 : _a.requestRender(); },
            getCamera: () => { var _a, _b; return (_b = (_a = getView()) === null || _a === void 0 ? void 0 : _a.getCamera()) !== null && _b !== void 0 ? _b : null; },
            resetCamera: (boundsToUse) => { var _a; return (_a = getView()) === null || _a === void 0 ? void 0 : _a.resetCamera(boundsToUse); },
        };
    }, [multiViewRoot]);
    react.useImperativeHandle(fwdRef, () => api);
    if (multiViewRoot) {
        return jsxRuntime.jsx(ParentedView, Object.assign({}, props, { ref: parentedViewRef }));
    }
    else {
        return jsxRuntime.jsx(SingleView, Object.assign({}, props, { ref: singleViewRef }));
    }
});

exports.Algorithm = Algorithm;
exports.Contexts = contexts;
exports.DataArray = DataArray;
exports.Geometry2DRepresentation = Geometry2DRepresentation;
exports.GeometryRepresentation = GeometryRepresentation;
exports.ImageData = ImageData;
exports.MultiViewRoot = MultiViewRoot;
exports.Picking = Picking;
exports.PointData = PointData;
exports.PolyData = PolyData;
exports.Reader = Reader;
exports.RegisterDataSet = RegisterDataSet;
exports.ShareDataSetRoot = ShareDataSetRoot;
exports.SliceRepresentation = SliceRepresentation;
exports.UseDataSet = UseDataSet;
exports.View = View;
