import { jsx } from 'react/jsx-runtime';
import { useCallback } from 'react';
import { useDataset, FieldDataContext } from './contexts.js';

function PointData(props) {
    const dataset = useDataset();
    const getPointData = useCallback(() => {
        return dataset.getDataSet().getPointData();
    }, [dataset]);
    return (jsx(FieldDataContext.Provider, Object.assign({ value: getPointData }, { children: props.children })));
}

export { PointData as default };
