import { IActorInitialValues } from '@kitware/vtk.js/Rendering/Core/Actor';
import { IMapperInitialValues } from '@kitware/vtk.js/Rendering/Core/Mapper';
import { IPropertyInitialValues } from '@kitware/vtk.js/Rendering/Core/Property';
import { PropsWithChildren } from 'react';
interface Props extends PropsWithChildren {
    /**
     * The ID used to identify this component.
     */
    id?: string;
    /**
     * Properties to set to the actor
     */
    actor?: IActorInitialValues;
    /**
     * Properties to set to the actor
     */
    mapper?: IMapperInitialValues;
    /**
     * Properties to set to the actor.property
     */
    property?: IPropertyInitialValues;
    /**
     * Preset name for the lookup table color map
     */
    colorMapPreset?: string;
    /**
     * Data range use for the colorMap
     */
    colorDataRange?: [number, number];
    /**
     * Show/Hide Cube Axes for the given representation
     */
    showCubeAxes?: boolean;
    /**
     * Configure cube Axes style by overriding the set of properties defined
     * https://github.com/Kitware/vtk-js/blob/HEAD/Sources/Rendering/Core/CubeAxesActor/index.js#L703-L719
     *
     * TODO fix type
     */
    cubeAxesStyle?: Record<string, unknown>;
    /**
     * Show hide scalar bar for that representation
     */
    showScalarBar?: boolean;
    /**
     * Use given string as title for scalar bar. By default it is empty (no title).
     */
    scalarBarTitle?: boolean;
    /**
     * Configure scalar bar style by overriding the set of properties defined
     * https://github.com/Kitware/vtk-js/blob/master/Sources/Rendering/Core/ScalarBarActor/index.js#L776-L796
     *
     * TODO fix type
     */
    scalarBarStyle?: Record<string, unknown>;
}
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
