import { PropsWithChildren } from 'react';
import { DataArrayValues, NumpyEncodedArray } from '../types';
interface Props extends PropsWithChildren {
    /**
     * downstream connection port
     */
    port?: number;
    /**
     * xyz coordinates ([] | TypedArray | { bvals, dtype, shape })
     */
    points?: DataArrayValues;
    /**
     * verts cells
     */
    verts?: number[] | Uint8Array | Uint8ClampedArray | Uint16Array | Uint32Array | NumpyEncodedArray;
    /**
     * lines cells
     */
    lines?: number[] | Uint8Array | Uint8ClampedArray | Uint16Array | Uint32Array | NumpyEncodedArray;
    /**
     * polys cells
     */
    polys?: number[] | Uint8Array | Uint8ClampedArray | Uint16Array | Uint32Array | NumpyEncodedArray;
    /**
     * strips cells
     */
    strips?: number[] | Uint8Array | Uint8ClampedArray | Uint16Array | Uint32Array | NumpyEncodedArray;
    /**
     * Type of connectivity `manual` or implicit such as `points`, `triangles`, `strips`
     */
    connectivity?: string;
}
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
