import { Vector2, Vector3 } from '@kitware/vtk.js/types';
export declare function valueCompareFirst<T extends unknown[]>(cur: T, prev: T): boolean;
export declare function shallowArrayCompareFirst<T extends unknown[][]>(cur: T, prev: T): boolean;
/**
 * Compares two objects.
 *
 * If any object is undefined, then the comparison fails.
 */
export declare function compareShallowObject<T>(cur: T | undefined, prev: T | undefined): boolean;
/**
 * Compares 2D vectors.
 */
export declare function compareVector2(cur: Vector2 | undefined, prev: Vector2 | undefined): boolean;
/**
 * Compares 3D vectors.
 *
 * If any vector is undefined, then the comparison fails.
 */
export declare function compareVector3(cur: Vector3 | undefined, prev: Vector3 | undefined): boolean;
/**
 * Compares arrays shallowly.
 */
export declare function compareShallowArray(cur: unknown[] | undefined, prev: unknown[] | undefined): boolean;
