import { debounce } from '@kitware/vtk.js/macros';
import { useRef, useEffect, useCallback } from 'react';

function useDebounce(fn, threshold) {
    const ref = useRef(debounce(fn, threshold));
    useEffect(() => {
        ref.current = debounce(fn, threshold);
    }, [fn, threshold]);
    const wrapper = useCallback((...args) => ref.current(...args), []);
    return wrapper;
}

export { useDebounce as default };
