import { useRef } from 'react';

function useGetterRef(initFunc) {
    const ref = useRef(null);
    const getterRef = useRef(() => {
        if (ref.current === null) {
            ref.current = initFunc();
        }
        return ref.current;
    });
    // these values are referentially stable
    return [ref, getterRef.current];
}

export { useGetterRef as default };
