import { useRef, useEffect } from 'react';

function useUnmount(func) {
    const funcRef = useRef(func);
    funcRef.current = func;
    useEffect(() => {
        return () => {
            funcRef.current();
        };
    }, []);
}

export { useUnmount as default };
