import { vtkRange } from '@kitware/vtk.js/interfaces';
import { TYPED_ARRAYS } from '@kitware/vtk.js/macros';
import { DataArrayValues } from '../types';
interface Props {
    /**
     * The ID used to identify this component.
     */
    name?: string;
    /**
     * Typed array name
     */
    type?: keyof typeof TYPED_ARRAYS;
    /**
     * Actual values to use inside our array ([] | TypedArray | { bvals, dtype, shape })
     */
    values?: DataArrayValues;
    /**
     * Number of components / Tuple size
     */
    numberOfComponents?: number;
    /**
     * Name of the method to call on the fieldData (addArray, setScalars, setVectors...)
     */
    registration?: string;
    /**
     * Data values range
     */
    range?: vtkRange;
}
export default function DataArray(props: Props): null;
export {};
