import { IActor2DInitialValues } from '@kitware/vtk.js/Rendering/Core/Actor2D';
import { ICoordinateInitialValues } from '@kitware/vtk.js/Rendering/Core/Coordinate';
import { IMapper2DInitialValues } from '@kitware/vtk.js/Rendering/Core/Mapper2D';
import { IProperty2DInitialValues } from '@kitware/vtk.js/Rendering/Core/Property2D';
import { PropsWithChildren } from 'react';
interface Props extends PropsWithChildren {
    /**
     * The ID used to identify this component.
     */
    id?: string;
    /**
     * Properties to set to the actor
     */
    actor?: IActor2DInitialValues;
    /**
     * Properties to set to the actor
     */
    mapper?: IMapper2DInitialValues;
    /**
     * Properties to set to the actor.property
     */
    property?: IProperty2DInitialValues;
    /**
     * Preset name for the lookup table color map
     */
    colorMapPreset?: string;
    /**
     * Data range use for the colorMap
     */
    colorDataRange?: [number, number];
    /**
     * The coordinate system in which the input dataset resides.
     */
    transformCoordinate?: ICoordinateInitialValues;
}
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
