import { IImageMapperInitialValues } from '@kitware/vtk.js/Rendering/Core/ImageMapper';
import { IImagePropertyInitialValues } from '@kitware/vtk.js/Rendering/Core/ImageProperty';
import { IImageSliceInitialValues } from '@kitware/vtk.js/Rendering/Core/ImageSlice';
import { Vector2 } from '@kitware/vtk.js/types';
import { PropsWithChildren } from 'react';
interface Props extends PropsWithChildren {
    /**
     * The ID used to identify this component.
     */
    id?: string;
    /**
     * Properties to set to the mapper
     */
    mapper?: IImageMapperInitialValues;
    /**
     * Properties to set to the slice/actor
     */
    actor?: IImageSliceInitialValues;
    /**
     * Properties to set to the volume.property
     */
    property?: IImagePropertyInitialValues;
    /**
     * Preset name for the lookup table color map
     */
    colorMapPreset?: string;
    /**
     * Data range use for the colorMap
     */
    colorDataRange?: 'auto' | Vector2;
    /**
     * index of the slice along i
     */
    iSlice?: number;
    /**
     * index of the slice along j
     */
    jSlice?: number;
    /**
     * index of the slice along k
     */
    kSlice?: number;
    /**
     * index of the slice along x
     */
    xSlice?: number;
    /**
     * index of the slice along y
     */
    ySlice?: number;
    /**
     * index of the slice along z
     */
    zSlice?: number;
}
declare const _default: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<unknown>>;
export default _default;
