/// <reference types="react" />
import vtkDataSet from '@kitware/vtk.js/Common/DataModel/DataSet';
import vtkDataSetAttributes from '@kitware/vtk.js/Common/DataModel/DataSetAttributes';
import vtkFieldData from '@kitware/vtk.js/Common/DataModel/DataSetAttributes/FieldData';
import { Nullable } from '@kitware/vtk.js/types';
import { IDataset, IDownstream, IOpenGLRenderWindow, IRenderer, IRenderWindow, IRepresentation, IShareDataset, IView } from '../types';
export declare const OpenGLRenderWindowContext: import("react").Context<IOpenGLRenderWindow | null>;
export declare const RenderWindowContext: import("react").Context<Nullable<IRenderWindow>>;
export declare const RendererContext: import("react").Context<IRenderer | null>;
export declare const FieldDataContext: import("react").Context<Nullable<() => vtkDataSetAttributes | vtkFieldData>>;
export declare const DatasetContext: import("react").Context<Nullable<IDataset<unknown>>>;
export declare const RepresentationContext: import("react").Context<Nullable<IRepresentation>>;
export declare const DownstreamContext: import("react").Context<Nullable<IDownstream>>;
export declare const ShareDataSetContext: import("react").Context<Nullable<IShareDataset>>;
export declare const MultiViewRootContext: import("react").Context<boolean>;
export declare const ViewContext: import("react").Context<IView | null>;
export declare function useRenderWindowContext(): IRenderWindow;
export declare function useRendererContext(): IRenderer;
export declare function useFieldData<T = vtkFieldData>(): () => T;
export declare function useDataset<T = vtkDataSet>(): IDataset<T>;
export declare function useRepresentation(): IRepresentation;
export declare function useDownstream(): IDownstream;
export declare function useShareDataSet(): IShareDataset;
