import { IMouseBoxSelectorManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseBoxSelectorManipulator';
import { IMouseCameraTrackballMultiRotateManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballMultiRotateManipulator';
import { IMouseCameraTrackballPanManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballPanManipulator';
import { IMouseCameraTrackballRollManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballRollManipulator';
import { IMouseCameraTrackballRotateManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballRotateManipulator';
import { IMouseCameraTrackballZoomManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballZoomManipulator';
import { IMouseCameraTrackballZoomToMouseManipulatorInitialValues } from '@kitware/vtk.js/Interaction/Manipulators/MouseCameraTrackballZoomToMouseManipulator';
import vtkInteractorStyle from '@kitware/vtk.js/Rendering/Core/InteractorStyle';
import vtkRenderWindowInteractor from '@kitware/vtk.js/Rendering/Core/RenderWindowInteractor';
interface PanSettings extends IMouseCameraTrackballPanManipulatorInitialValues {
    action: 'Pan';
}
interface ZoomSettings extends IMouseCameraTrackballZoomManipulatorInitialValues {
    action: 'Zoom';
}
interface RollSettings extends IMouseCameraTrackballRollManipulatorInitialValues {
    action: 'Roll';
}
interface RotateSettings extends IMouseCameraTrackballRotateManipulatorInitialValues {
    action: 'Rotate';
}
interface MultiRotateSettings extends IMouseCameraTrackballMultiRotateManipulatorInitialValues {
    action: 'MultiRotate';
}
interface ZoomToMouseSettings extends IMouseCameraTrackballZoomToMouseManipulatorInitialValues {
    action: 'ZoomToMouse';
}
interface SelectSettings extends IMouseBoxSelectorManipulatorInitialValues {
    action: 'Select';
}
export type ManipulatorSettings = PanSettings | ZoomSettings | RollSettings | RotateSettings | MultiRotateSettings | ZoomToMouseSettings | SelectSettings;
export declare function useInteractorStyleManipulatorSettings(getStyle: () => vtkInteractorStyle, settings: ManipulatorSettings[]): void;
export declare function useInteractorStyle(getInteractor: () => vtkRenderWindowInteractor | null): readonly [() => vtkInteractorStyle, (style: vtkInteractorStyle) => void];
export {};
