/// <reference types="react" />
export type ResizeWatcherCallback = (target: Element) => void;
export type ResizeWatcherStop = () => void;
export interface IResizeWatcher {
    watch(element: Element, callback: ResizeWatcherCallback): void;
    unwatch(element: Element, callback: ResizeWatcherCallback): void;
}
export declare const ResizeWatcherContext: import("react").Context<IResizeWatcher | null>;
/**
 * A variant of ResizeObserver that acts similarly to add/removeEventListener.
 */
export declare class ResizeWatcher implements IResizeWatcher {
    private resizeObserver;
    private callbacks;
    constructor();
    onResize(entries: ResizeObserverEntry[]): void;
    watch(element: Element, callback: ResizeWatcherCallback): void;
    unwatch(element: Element, callback: ResizeWatcherCallback): void;
}
