import { DependencyList, EffectCallback } from 'react';
type Comparator<T extends DependencyList> = (cur: T, prev: T) => boolean;
/**
 * useEffect, but with a custom dependency array comparator.
 *
 * If the comparator returns false, the effect is run.
 */
export default function useComparableEffect<D extends DependencyList = DependencyList>(callback: EffectCallback, deps: D, comparator: Comparator<D>): void;
export {};
